/*
 *  Author     : Arne Vajhj
 *
 *  Programmed : february 1996
 *
 *  Purpose    : MS-Windows client DECnet interface to QI-server
 *
 */
#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "phw.h"
#include "ph.h"

char phweditstr[80];
char buffer[NLIN][80];

int hunits,wunits;
int offset = 0;
int bufix = 0;

void strfillcopy(int n, char *s)
{
   int i;
   strcpy(buffer[n],s);
   for(i=strlen(s);i<80;i++) buffer[n][i]=' ';
   if(buffer[n][strlen(s)-1]=='\n') buffer[n][strlen(s)-1]=' ';
   return;
}

#define clearbuffer(i) for(i=0;i<bufix;i++) strfillcopy(i,""); \
                       offset = 0;
#define refreshwindow InvalidateRect(hWnd,NULL,TRUE); \
                      UpdateWindow(hWnd);

void doit(char *s)
{
   strfillcopy(bufix,s);
   bufix++;
   return;    
}

void phonebook()
{
   int i;
   if(strlen(phweditstr)>0) {
      bufix = 0;
      clearbuffer(i);
      if(!query_one_in_all(phweditstr,doit)) strfillcopy(0,NETWORKERROR);
   } else {
      strfillcopy(0,NOSEARCHITEM);
   }
   return;
}

HANDLE hInst;
HANDLE hAccTable;
HWND hWnd;

void copy2clipboard()
{
   HANDLE hData;
   LPSTR lpData;
   int i,l;
   char tmp[20000];
   if(!(hData = GlobalAlloc(GMEM_MOVEABLE,20000))) {
      OutOfmemory();
      return; 
   }
   if(!(lpData = GlobalLock(hData))) {
      OutOfmemory();
      return; 
   }
   l = 0;
   for(i=0;i<bufix;i++) {
      memcpy(tmp+l,buffer[i],80);
      l = l+80;
      while(tmp[l-1]==' ') l--;
      strcpy(tmp+l,"\r\n");
      l = l+2;
   }
   lstrcpy(lpData,tmp);
   GlobalUnlock(hData);
   if(OpenClipboard(hWnd)) {
      EmptyClipboard();
      SetClipboardData(CF_TEXT,hData);
      CloseClipboard();
   }
   return;
}

int PASCAL WinMain(HANDLE hInstance,
                   HANDLE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
   MSG msg;
   if (!hPrevInstance)
      if (!InitApplication(hInstance))
         return (FALSE);
   if (!InitInstance(hInstance,nCmdShow))
      return (FALSE);
   while (GetMessage(&msg,NULL,NULL,NULL)) {
      if(!TranslateAccelerator(hWnd,hAccTable,&msg)) {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      }
   }
   return (msg.wParam);
}

BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS wc;
    wc.style = NULL;
    wc.lpfnWndProc = MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance,"PHWIcon");
    wc.hCursor = LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = "PHWMenu";
    wc.lpszClassName = PHWWClass;
    return (RegisterClass(&wc));
}

BOOL InitInstance(HANDLE hInstance,int nCmdShow)
{
   int i,j;
   wunits = LOWORD(GetDialogBaseUnits())/4;
   hunits = HIWORD(GetDialogBaseUnits())/8;
   for(i=0;i<NLIN;i++) for(j=0;j<80;j++) buffer[i][j]=' ';
   hInst = hInstance;
   hAccTable = LoadAccelerators(hInst,"PHWacc");
   hWnd = CreateWindow(PHWWClass,
                       PHWWin,
                       WS_OVERLAPPEDWINDOW|WS_VSCROLL,
                       20*wunits,
                       20*hunits,
                       240*wunits,
                       200*hunits,
                       NULL,
                       NULL,
                       hInstance,
                       NULL);
    if (!hWnd)
       return (FALSE);
    ShowWindow(hWnd,nCmdShow);
    UpdateWindow(hWnd);
    return (TRUE);
}

long FAR PASCAL MainWndProc(HWND hWnd,
                            UINT message,
                            WPARAM wParam,
                            LPARAM lParam)
{
    FARPROC lpProcTest;
    HDC hDC;
    PAINTSTRUCT ps;
    int i,tmp;
    switch (message) {
       case WM_INITMENU:
         if (wParam == GetMenu(hWnd)) {
            if (OpenClipboard(hWnd)) {
               if (bufix>0) {
                  EnableMenuItem(wParam,IDM_PHW3,MF_ENABLED);
                  EnableMenuItem(wParam,IDM_PHW4,MF_ENABLED);
                  EnableMenuItem(wParam,IDM_PHW6,MF_ENABLED);
               } else {
                  EnableMenuItem(wParam,IDM_PHW3,MF_GRAYED);
                  EnableMenuItem(wParam,IDM_PHW4,MF_GRAYED);
                  EnableMenuItem(wParam,IDM_PHW6,MF_GRAYED);
               }
               CloseClipboard();
               return (TRUE);
            } else {
               return (FALSE);
            }
         } 
         return (TRUE);
       case WM_COMMAND:
          if (wParam == IDM_PHW1) {
             lpProcTest = MakeProcInstance(LookUp, hInst);
             DialogBox(hInst,"LookupBox",hWnd,lpProcTest);
             FreeProcInstance(lpProcTest);
             break;
          } else if(wParam == IDM_PHW2) {
             PostQuitMessage(0);
             break;
          } else if(wParam == IDM_PHW3) {
             copy2clipboard();
             clearbuffer(i);
             refreshwindow;
             break;
          } else if(wParam == IDM_PHW4) {
             copy2clipboard();
             break;
          } else if(wParam == IDM_PHW5) {
             MessageBox(GetFocus(),
                        "Command not implemented.",
                        PHWWin,
                        MB_ICONASTERISK | MB_OK);
             break;
          } else if(wParam == IDM_PHW6) {
             clearbuffer(i);
             refreshwindow;
             break;
          } else if(wParam == IDM_PHW7) {
             lpProcTest = MakeProcInstance(About, hInst);
             DialogBox(hInst,"AboutBox",hWnd,lpProcTest);
             FreeProcInstance(lpProcTest);
             break;
          } else
             return (DefWindowProc(hWnd,message,wParam,lParam));
       case WM_PAINT:
          hDC = BeginPaint(hWnd, &ps);
          for(i=0;i<19;i++) {
             TextOut(hDC,20,10+i*10*hunits,buffer[offset+i],80);
          }
          EndPaint(hWnd, &ps);
          tmp = (offset*100L)/(NLIN-18);
          SetScrollPos(hWnd,SB_VERT,tmp,TRUE);
          break;
       case WM_VSCROLL:
          switch (wParam) {
             case SB_LINEUP:
                offset--;
                break;
             case SB_LINEDOWN:
                offset++;
                break;
             case SB_PAGEUP:
                offset = offset - 19;
                break;
             case SB_PAGEDOWN:
                offset = offset + 19;
                break;
             case SB_THUMBPOSITION:
             case SB_THUMBTRACK:
                offset = (LOWORD(lParam)*(NLIN-18))/100L;
                break;
          }
          if(offset<0) offset=0;
          if(offset>(NLIN-18)) offset=NLIN-18;
          refreshwindow;
          break;
       case WM_DESTROY:
          PostQuitMessage(0);
          break;
       default:
          return (DefWindowProc(hWnd,message,wParam,lParam));
    }
    return (NULL);
}

BOOL FAR PASCAL LookUp(HWND hDlg,
                       unsigned message,
                       WORD wParam,
                       LONG lParam)
{
    char retbuf[80];
    int retbuflen,retbufsiz;
    HCURSOR hcurSave;
    retbufsiz = sizeof(retbuf);
    switch (message) {
       case WM_INITDIALOG:
          return (TRUE);
       case WM_COMMAND:
          if (wParam == IDOK) {
             retbuflen = GetDlgItemText(hDlg,EDT,(LPSTR)retbuf,retbufsiz);
             retbuf[retbuflen] = '\0';
             strcpy(phweditstr,retbuf);
             EndDialog(hDlg, TRUE);
             hcurSave = SetCursor(LoadCursor(NULL,IDC_WAIT));
             phonebook();
             SetCursor(hcurSave);
             SendMessage(FindWindow(PHWWClass,PHWWin),WM_PAINT,0,0);
             RedrawWindow(FindWindow(PHWWClass,PHWWin),NULL,NULL,RDW_INVALIDATE);
             return (TRUE);
          } else if (wParam == IDCANCEL) {
             EndDialog(hDlg, TRUE);
             return (TRUE);
          }
          break;
    }
    return (FALSE);
}

BOOL FAR PASCAL About(HWND hDlg,
                      unsigned message,
                      WORD wParam,
                      LONG lParam)
{
    switch (message) {
       case WM_INITDIALOG:
          return (TRUE);
       case WM_COMMAND:
          if (wParam == IDOK) {
             EndDialog(hDlg, TRUE);
             return (TRUE);
          } else if (wParam == IDCANCEL) {
             EndDialog(hDlg, TRUE);
             return (TRUE);
          }
          break;
    }
    return (FALSE);
}

void OutOfMemory(void)
{
    MessageBox(GetFocus(),
               "Out of Memory.",
               PHWWin,
               MB_ICONHAND | MB_SYSTEMMODAL );
    return;
}
